stages:
#  - fixed
  - simple
  - partitioned
  - parted
  - mount

#losetup-fixed:
#  stage: fixed
#  tags:
#    - arm64-runner
#  script:
#    - cat /proc/partitions
#    - ls /sys/block
#    - ls /sys/dev/block
#    - apt update
#    - apt -y install bsdextrautils
#    - dd if=/dev/zero of=test.img bs=1M count=10
#    - mknod /dev/loop0 b 7 0 || true
#    - losetup -P --show /dev/loop0 test.img
#    - dd if=/dev/urandom of=/dev/loop0 bs=1024 count=10
#    - hexdump -C /dev/loop0
#    - losetup -d /dev/loop0

losetup-simple:
  stage: simple
  tags:
    - arm64-runner
  script:
    - cat /proc/partitions
    - ls /sys/block
    - ls /sys/dev/block
    - apt update
    - apt -y install bsdextrautils
    - dd if=/dev/zero of=test.img bs=1M count=10
    - loop=$(losetup -P --show -f test.img)
    - dd if=/dev/urandom of=${loop} bs=1024 count=10
    - hexdump -C ${loop}
    - losetup -d ${loop}

losetup-partitioned:
  stage: partitioned
  tags:
    - arm64-runner
  script:
    - cat /proc/partitions
    - ls /sys/block
    - ls /sys/dev/block
    - apt update
    - apt -y install bsdextrautils parted
    - dd if=/dev/zero of=test.img bs=1M count=10
    - parted -s test.img mklabel gpt
    - parted -s test.img mkpart primary "fat32" 1048576B 2097151B
    - parted -s test.img set 1 boot on
    - parted -s test.img mkpart primary 'ext3' 2097152B 10468351B
    - loop=$(losetup -P --show -f test.img)
    - cat /proc/partitions
    - ls -l /dev/loop*
    - dd if=/dev/urandom of=${loop}p1 bs=1024 count=10
    - hexdump -C ${loop}p1
    - hexdump -C ${loop}
    - losetup -d ${loop}

losetup-parted:
  stage: parted
  tags:
    - arm64-runner
  script:
    - cat /proc/partitions
    - ls /sys/block
    - ls /sys/dev/block
    - apt update
    - apt -y install bsdextrautils parted
    - dd if=/dev/zero of=test.img bs=1M count=10
    - loop=$(losetup -P --show -f test.img)
    - parted -s ${loop} mklabel gpt
    - parted -s ${loop} mkpart primary "fat32" 1048576B 2097151B
    - parted -s ${loop} set 1 boot on
    - parted -s ${loop} mkpart primary 'ext3' 2097152B 10468351B
    - cat /proc/partitions
    - ls -l /dev/loop*
    - dd if=/dev/urandom of=${loop}p1 bs=1024 count=10
    - hexdump -C ${loop}p1
    - hexdump -C ${loop}
    - losetup -d ${loop}


losetup-mount:
  stage: mount
  tags:
    - arm64-runner
  script:
    - cat /proc/partitions
    - ls /sys/block
    - ls /sys/dev/block
    - apt update
    - apt -y install bsdextrautils parted e2fsprogs
    - chmod +x bin/udevadm
    - export PATH=$PATH:`pwd`/bin
    - dd if=/dev/zero of=test.img bs=1M count=10
    - loop=$(losetup -P --show -f test.img)
    - parted -s ${loop} mklabel gpt
    - parted -s ${loop} mkpart primary "fat32" 1048576B 2097151B
    - parted -s ${loop} set 1 boot on
    - parted -s ${loop} mkpart primary 'ext3' 2097152B 10468351B
    - cat /proc/partitions
    - ls -l /dev/loop*
    - dd if=/dev/urandom of=${loop}p1 bs=1024 count=1
    - hexdump -C ${loop}
    - mkfs.ext4 ${loop}p2
    - mkdir tmp
    - mount ${loop}p2 tmp
    - date > tmp/test
    - umount tmp
    - hexdump -C ${loop}
    - losetup -d ${loop}
